--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -22,210 +22,56 @@
 /*
  * Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
  */
+
 /*
+ * Copyright 2011 cyril.galibern@opensvc.com
  * Copyright (c) 2011 Bayard G. Bell.  All rights reserved.
  * Copyright (c) 2012, 2016 by Delphix. All rights reserved.
  * Copyright 2012 DEY Storage Systems, Inc.  All rights reserved.
- * Copyright 2017 Nexenta Systems, Inc.
+ * Copyright 2019 Nexenta Systems, Inc.
  */
-/*
- * Copyright 2011 cyril.galibern@opensvc.com
- */
 
 /*
  * SCSI disk target driver.
  */
-#include <sys/scsi/scsi.h>
+#include <sys/aio_req.h>
+#include <sys/byteorder.h>
+#include <sys/cdio.h>
+#include <sys/cmlb.h>
+#include <sys/debug.h>
 #include <sys/dkbad.h>
-#include <sys/dklabel.h>
 #include <sys/dkio.h>
-#include <sys/fdio.h>
-#include <sys/cdio.h>
-#include <sys/mhd.h>
-#include <sys/vtoc.h>
+#include <sys/dkioc_free_util.h>
+#include <sys/dklabel.h>
 #include <sys/dktp/fdisk.h>
+#include <sys/efi_partition.h>
+#include <sys/fdio.h>
+#include <sys/fm/protocol.h>
+#include <sys/fs/dv_node.h>
 #include <sys/kstat.h>
-#include <sys/vtrace.h>
-#include <sys/note.h>
-#include <sys/thread.h>
+#include <sys/mhd.h>
 #include <sys/proc.h>
-#include <sys/efi_partition.h>
-#include <sys/var.h>
-#include <sys/aio_req.h>
-
-#ifdef __lock_lint
-#define	_LP64
-#define	__amd64
-#endif
-
-#if (defined(__fibre))
-/* Note: is there a leadville version of the following? */
-#include <sys/fc4/fcal_linkapp.h>
-#endif
+#include <sys/scsi/scsi.h>
+#include <sys/scsi/targets/sddef.h>
+#include <sys/sdt.h>
+#include <sys/sysevent/dev.h>
+#include <sys/sysevent/eventdefs.h>
 #include <sys/taskq.h>
+#include <sys/thread.h>
 #include <sys/uuid.h>
-#include <sys/byteorder.h>
-#include <sys/sdt.h>
+#include <sys/var.h>
+#include <sys/vtoc.h>
+#include <sys/vtrace.h>
 
 #include "sd_xbuf.h"
 
-#include <sys/scsi/targets/sddef.h>
-#include <sys/cmlb.h>
-#include <sys/sysevent/eventdefs.h>
-#include <sys/sysevent/dev.h>
-
-#include <sys/fm/protocol.h>
-
-/*
- * Loadable module info.
- */
-#if (defined(__fibre))
-#define	SD_MODULE_NAME	"SCSI SSA/FCAL Disk Driver"
-#else /* !__fibre */
 #define	SD_MODULE_NAME	"SCSI Disk Driver"
-#endif /* !__fibre */
+static	char *sd_label = "sd";
 
 /*
- * Define the interconnect type, to allow the driver to distinguish
- * between parallel SCSI (sd) and fibre channel (ssd) behaviors.
- *
- * This is really for backward compatibility. In the future, the driver
- * should actually check the "interconnect-type" property as reported by
- * the HBA; however at present this property is not defined by all HBAs,
- * so we will use this #define (1) to permit the driver to run in
- * backward-compatibility mode; and (2) to print a notification message
- * if an FC HBA does not support the "interconnect-type" property.  The
- * behavior of the driver will be to assume parallel SCSI behaviors unless
- * the "interconnect-type" property is defined by the HBA **AND** has a
- * value of either INTERCONNECT_FIBRE, INTERCONNECT_SSA, or
- * INTERCONNECT_FABRIC, in which case the driver will assume Fibre
- * Channel behaviors (as per the old ssd).  (Note that the
- * INTERCONNECT_1394 and INTERCONNECT_USB types are not supported and
- * will result in the driver assuming parallel SCSI behaviors.)
- *
- * (see common/sys/scsi/impl/services.h)
- *
- * Note: For ssd semantics, don't use INTERCONNECT_FABRIC as the default
- * since some FC HBAs may already support that, and there is some code in
- * the driver that already looks for it.  Using INTERCONNECT_FABRIC as the
- * default would confuse that code, and besides things should work fine
- * anyways if the FC HBA already reports INTERCONNECT_FABRIC for the
- * "interconnect_type" property.
- *
- */
-#if (defined(__fibre))
-#define	SD_DEFAULT_INTERCONNECT_TYPE	SD_INTERCONNECT_FIBRE
-#else
-#define	SD_DEFAULT_INTERCONNECT_TYPE	SD_INTERCONNECT_PARALLEL
-#endif
-
-/*
- * The name of the driver, established from the module name in _init.
- */
-static	char *sd_label			= NULL;
-
-/*
- * Driver name is unfortunately prefixed on some driver.conf properties.
- */
-#if (defined(__fibre))
-#define	sd_max_xfer_size		ssd_max_xfer_size
-#define	sd_config_list			ssd_config_list
-static	char *sd_max_xfer_size		= "ssd_max_xfer_size";
-static	char *sd_config_list		= "ssd-config-list";
-#else
-static	char *sd_max_xfer_size		= "sd_max_xfer_size";
-static	char *sd_config_list		= "sd-config-list";
-#endif
-
-/*
  * Driver global variables
  */
 
-#if (defined(__fibre))
-/*
- * These #defines are to avoid namespace collisions that occur because this
- * code is currently used to compile two separate driver modules: sd and ssd.
- * All global variables need to be treated this way (even if declared static)
- * in order to allow the debugger to resolve the names properly.
- * It is anticipated that in the near future the ssd module will be obsoleted,
- * at which time this namespace issue should go away.
- */
-#define	sd_state			ssd_state
-#define	sd_io_time			ssd_io_time
-#define	sd_failfast_enable		ssd_failfast_enable
-#define	sd_ua_retry_count		ssd_ua_retry_count
-#define	sd_report_pfa			ssd_report_pfa
-#define	sd_max_throttle			ssd_max_throttle
-#define	sd_min_throttle			ssd_min_throttle
-#define	sd_rot_delay			ssd_rot_delay
-
-#define	sd_retry_on_reservation_conflict	\
-					ssd_retry_on_reservation_conflict
-#define	sd_reinstate_resv_delay		ssd_reinstate_resv_delay
-#define	sd_resv_conflict_name		ssd_resv_conflict_name
-
-#define	sd_component_mask		ssd_component_mask
-#define	sd_level_mask			ssd_level_mask
-#define	sd_debug_un			ssd_debug_un
-#define	sd_error_level			ssd_error_level
-
-#define	sd_xbuf_active_limit		ssd_xbuf_active_limit
-#define	sd_xbuf_reserve_limit		ssd_xbuf_reserve_limit
-
-#define	sd_tr				ssd_tr
-#define	sd_reset_throttle_timeout	ssd_reset_throttle_timeout
-#define	sd_qfull_throttle_timeout	ssd_qfull_throttle_timeout
-#define	sd_qfull_throttle_enable	ssd_qfull_throttle_enable
-#define	sd_check_media_time		ssd_check_media_time
-#define	sd_wait_cmds_complete		ssd_wait_cmds_complete
-#define	sd_label_mutex			ssd_label_mutex
-#define	sd_detach_mutex			ssd_detach_mutex
-#define	sd_log_buf			ssd_log_buf
-#define	sd_log_mutex			ssd_log_mutex
-
-#define	sd_disk_table			ssd_disk_table
-#define	sd_disk_table_size		ssd_disk_table_size
-#define	sd_sense_mutex			ssd_sense_mutex
-#define	sd_cdbtab			ssd_cdbtab
-
-#define	sd_cb_ops			ssd_cb_ops
-#define	sd_ops				ssd_ops
-#define	sd_additional_codes		ssd_additional_codes
-#define	sd_tgops			ssd_tgops
-
-#define	sd_minor_data			ssd_minor_data
-#define	sd_minor_data_efi		ssd_minor_data_efi
-
-#define	sd_tq				ssd_tq
-#define	sd_wmr_tq			ssd_wmr_tq
-#define	sd_taskq_name			ssd_taskq_name
-#define	sd_wmr_taskq_name		ssd_wmr_taskq_name
-#define	sd_taskq_minalloc		ssd_taskq_minalloc
-#define	sd_taskq_maxalloc		ssd_taskq_maxalloc
-
-#define	sd_dump_format_string		ssd_dump_format_string
-
-#define	sd_iostart_chain		ssd_iostart_chain
-#define	sd_iodone_chain			ssd_iodone_chain
-
-#define	sd_pm_idletime			ssd_pm_idletime
-
-#define	sd_force_pm_supported		ssd_force_pm_supported
-
-#define	sd_dtype_optical_bind		ssd_dtype_optical_bind
-
-#define	sd_ssc_init			ssd_ssc_init
-#define	sd_ssc_send			ssd_ssc_send
-#define	sd_ssc_fini			ssd_ssc_fini
-#define	sd_ssc_assessment		ssd_ssc_assessment
-#define	sd_ssc_post			ssd_ssc_post
-#define	sd_ssc_print			ssd_ssc_print
-#define	sd_ssc_ereport_post		ssd_ssc_ereport_post
-#define	sd_ssc_set_info			ssd_ssc_set_info
-#define	sd_ssc_extract_info		ssd_ssc_extract_info
-
-#endif
-
 #ifdef	SDDEBUG
 int	sd_force_pm_supported		= 0;
 #endif	/* SDDEBUG */
@@ -232,7 +78,6 @@
 
 void *sd_state				= NULL;
 int sd_io_time				= SD_IO_TIME;
-int sd_failfast_enable			= 1;
 int sd_ua_retry_count			= SD_UA_RETRY_COUNT;
 int sd_report_pfa			= 1;
 int sd_max_throttle			= SD_MAX_THROTTLE;
@@ -242,13 +87,14 @@
 
 int sd_retry_on_reservation_conflict	= 1;
 int sd_reinstate_resv_delay		= SD_REINSTATE_RESV_DELAY;
-_NOTE(SCHEME_PROTECTS_DATA("safe sharing", sd_reinstate_resv_delay))
+int sd_enable_lun_reset			= FALSE;
 
-static int sd_dtype_optical_bind	= -1;
+/*
+ * Default safe I/O delay threshold of 30s for all devices.
+ * Can be overriden for vendor/device id in sd.conf
+ */
+hrtime_t sd_slow_io_threshold		= 30LL * NANOSEC;
 
-/* Note: the following is not a bug, it really is "sd_" and not "ssd_" */
-static	char *sd_resv_conflict_name	= "sd_retry_on_reservation_conflict";
-
 /*
  * Global data for debug logging. To enable debug printing, sd_component_mask
  * and sd_level_mask should be set to the desired bit patterns as outlined in
@@ -294,9 +140,6 @@
  */
 static kmutex_t sd_detach_mutex;
 
-_NOTE(MUTEX_PROTECTS_DATA(sd_detach_mutex,
-	sd_lun::{un_layer_count un_detach_count un_opens_in_progress}))
-
 /*
  * Global buffer and mutex for debug logging
  */
@@ -325,12 +168,6 @@
 static kmutex_t	sd_scsi_target_lun_mutex;
 static struct sd_scsi_hba_tgt_lun	*sd_scsi_target_lun_head = NULL;
 
-_NOTE(MUTEX_PROTECTS_DATA(sd_scsi_target_lun_mutex,
-    sd_scsi_hba_tgt_lun::next sd_scsi_hba_tgt_lun::pdip))
-
-_NOTE(MUTEX_PROTECTS_DATA(sd_scsi_target_lun_mutex,
-    sd_scsi_target_lun_head))
-
 /*
  * "Smart" Probe Caching structs, globals, #defines, etc.
  * For parallel scsi and non-self-identify device only.
@@ -351,16 +188,42 @@
 static struct	sd_scsi_probe_cache *sd_scsi_probe_cache_head = NULL;
 
 /*
- * Really we only need protection on the head of the linked list, but
- * better safe than sorry.
+ * Create taskq for all targets in the system. This is created at
+ * _init(9E) and destroyed at _fini(9E).
+ *
+ * Note: here we set the minalloc to a reasonably high number to ensure that
+ * we will have an adequate supply of task entries available at interrupt time.
+ * This is used in conjunction with the TASKQ_PREPOPULATE flag in
+ * sd_create_taskq().  Since we do not want to sleep for allocations at
+ * interrupt time, set maxalloc equal to minalloc. That way we will just fail
+ * the command if we ever try to dispatch more than SD_TASKQ_MAXALLOC taskq
+ * requests any one instant in time.
  */
-_NOTE(MUTEX_PROTECTS_DATA(sd_scsi_probe_cache_mutex,
-    sd_scsi_probe_cache::next sd_scsi_probe_cache::pdip))
+#define	SD_TASKQ_NUMTHREADS	8
+#define	SD_TASKQ_MINALLOC	256
+#define	SD_TASKQ_MAXALLOC	256
 
-_NOTE(MUTEX_PROTECTS_DATA(sd_scsi_probe_cache_mutex,
-    sd_scsi_probe_cache_head))
+static taskq_t	*sd_tq = NULL;
 
+static int	sd_taskq_minalloc = SD_TASKQ_MINALLOC;
+static int	sd_taskq_maxalloc = SD_TASKQ_MAXALLOC;
+
+#define SD_BAIL_CHECK(a) if ((a)->un_detach_count != 0) { \
+	mutex_exit(SD_MUTEX((a))); \
+	return (ENXIO); \
+	}
 /*
+ * The following task queue is being created for the write part of
+ * read-modify-write of non-512 block size devices.
+ * Limit the number of threads to 1 for now. This number has been chosen
+ * considering the fact that it applies only to dvd ram drives/MO drives
+ * currently. Performance for which is not main criteria at this stage.
+ * Note: It needs to be explored if we can use a single taskq in future
+ */
+#define	SD_WMR_TASKQ_NUMTHREADS	1
+static taskq_t	*sd_wmr_tq = NULL;
+
+/*
  * Power attribute table
  */
 static sd_power_attr_ss sd_pwr_ss = {
@@ -392,8 +255,6 @@
  * Vendor specific data name property declarations
  */
 
-#if defined(__fibre) || defined(__i386) ||defined(__amd64)
-
 static sd_tunables seagate_properties = {
 	SEAGATE_THROTTLE_VALUE,
 	0,
@@ -406,7 +267,6 @@
 	0
 };
 
-
 static sd_tunables fujitsu_properties = {
 	FUJITSU_THROTTLE_VALUE,
 	0,
@@ -479,12 +339,6 @@
 	PIRUS_LUN_RESET_ENABLED_FLAG
 };
 
-#endif
-
-#if (defined(__sparc) && !defined(__fibre)) || \
-	(defined(__i386) || defined(__amd64))
-
-
 static sd_tunables elite_properties = {
 	ELITE_THROTTLE_VALUE,
 	0,
@@ -509,8 +363,6 @@
 	0
 };
 
-#endif /* Fibre or not */
-
 static sd_tunables lsi_properties_scsi = {
 	LSI_THROTTLE_VALUE,
 	0,
@@ -560,10 +412,7 @@
 	1
 };
 
-
-
 #if (defined(SD_PROP_TST))
-
 #define	SD_TST_CTYPE_VAL	CTYPE_CDROM
 #define	SD_TST_THROTTLE_VAL	16
 #define	SD_TST_NOTREADY_VAL	12
@@ -570,7 +419,6 @@
 #define	SD_TST_BUSY_VAL		60
 #define	SD_TST_RST_RETRY_VAL	36
 #define	SD_TST_RSV_REL_TIME	60
-
 static sd_tunables tst_properties = {
 	SD_TST_THROTTLE_VAL,
 	SD_TST_CTYPE_VAL,
@@ -615,7 +463,6 @@
  *	 made with an FC connection. The entries here are a legacy.
  */
 static sd_disk_config_t sd_disk_table[] = {
-#if defined(__fibre) || defined(__i386) || defined(__amd64)
 	{ "SEAGATE ST34371FC", SD_CONF_BSET_THROTTLE, &seagate_properties },
 	{ "SEAGATE ST19171FC", SD_CONF_BSET_THROTTLE, &seagate_properties },
 	{ "SEAGATE ST39102FC", SD_CONF_BSET_THROTTLE, &seagate_properties },
@@ -665,137 +512,136 @@
 	{ "ENGENIO INF",	SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "SGI     TP",		SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "SGI     IS",		SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
-	{ "*CSM100_*",		SD_CONF_BSET_NRR_COUNT |
-			SD_CONF_BSET_CACHE_IS_NV, &lsi_oem_properties },
-	{ "*CSM200_*",		SD_CONF_BSET_NRR_COUNT |
-			SD_CONF_BSET_CACHE_IS_NV, &lsi_oem_properties },
-	{ "Fujitsu SX300",	SD_CONF_BSET_THROTTLE,  &lsi_oem_properties },
+	{ "*CSM100_*",		SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_CACHE_IS_NV,
+				&lsi_oem_properties },
+	{ "*CSM200_*",		SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_CACHE_IS_NV,
+				&lsi_oem_properties },
+	{ "Fujitsu SX300",	SD_CONF_BSET_THROTTLE, &lsi_oem_properties },
 	{ "LSI",		SD_CONF_BSET_NRR_COUNT, &lsi_properties },
-	{ "SUN     T3", SD_CONF_BSET_THROTTLE |
-			SD_CONF_BSET_BSY_RETRY_COUNT|
-			SD_CONF_BSET_RST_RETRIES|
-			SD_CONF_BSET_RSV_REL_TIME,
-		&purple_properties },
-	{ "SUN     SESS01", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_RSV_REL_TIME|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED,
-		&sve_properties },
-	{ "SUN     T4", SD_CONF_BSET_THROTTLE |
-			SD_CONF_BSET_BSY_RETRY_COUNT|
-			SD_CONF_BSET_RST_RETRIES|
-			SD_CONF_BSET_RSV_REL_TIME,
-		&purple_properties },
-	{ "SUN     SVE01", SD_CONF_BSET_DISKSORT_DISABLED |
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&maserati_properties },
-	{ "SUN     SE6920", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
-	{ "SUN     SE6940", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
-	{ "SUN     StorageTek 6920", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
-	{ "SUN     StorageTek 6940", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
-	{ "SUN     PSX1000", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
-	{ "SUN     SE6330", SD_CONF_BSET_THROTTLE |
-		SD_CONF_BSET_NRR_COUNT|
-		SD_CONF_BSET_BSY_RETRY_COUNT|
-		SD_CONF_BSET_RST_RETRIES|
-		SD_CONF_BSET_MIN_THROTTLE|
-		SD_CONF_BSET_DISKSORT_DISABLED|
-		SD_CONF_BSET_LUN_RESET_ENABLED,
-		&pirus_properties },
+	{ "SUN     T3",		SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_RSV_REL_TIME,
+				&purple_properties },
+	{ "SUN     SESS01",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_RSV_REL_TIME|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED,
+				&sve_properties },
+	{ "SUN     T4",		SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_RSV_REL_TIME,
+				&purple_properties },
+	{ "SUN     SVE01",	SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&maserati_properties },
+	{ "SUN     SE6920",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
+	{ "SUN     SE6940",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
+	{ "SUN     StorageTek 6920", SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
+	{ "SUN     StorageTek 6940", SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
+	{ "SUN     PSX1000",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
+	{ "SUN     SE6330",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_MIN_THROTTLE|
+				SD_CONF_BSET_DISKSORT_DISABLED|
+				SD_CONF_BSET_LUN_RESET_ENABLED,
+				&pirus_properties },
 	{ "SUN     STK6580_6780", SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
-	{ "SUN     SUN_6180", SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
+	{ "SUN     SUN_6180",	SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "STK     OPENstorage", SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "STK     OpenStorage", SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "STK     BladeCtlr",	SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
 	{ "STK     FLEXLINE",	SD_CONF_BSET_NRR_COUNT, &lsi_oem_properties },
-	{ "SYMBIOS", SD_CONF_BSET_NRR_COUNT, &symbios_properties },
-#endif /* fibre or NON-sparc platforms */
-#if ((defined(__sparc) && !defined(__fibre)) ||\
-	(defined(__i386) || defined(__amd64)))
-	{ "SEAGATE ST42400N", SD_CONF_BSET_THROTTLE, &elite_properties },
-	{ "SEAGATE ST31200N", SD_CONF_BSET_THROTTLE, &st31200n_properties },
-	{ "SEAGATE ST41600N", SD_CONF_BSET_TUR_CHECK, NULL },
-	{ "CONNER  CP30540",  SD_CONF_BSET_NOCACHE,  NULL },
-	{ "*SUN0104*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN0207*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN0327*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN0340*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN0424*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN0669*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "*SUN1.0G*", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "SYMBIOS INF-01-00       ", SD_CONF_BSET_FAB_DEVID, NULL },
-	{ "SYMBIOS", SD_CONF_BSET_THROTTLE|SD_CONF_BSET_NRR_COUNT,
-	    &symbios_properties },
-	{ "LSI", SD_CONF_BSET_THROTTLE | SD_CONF_BSET_NRR_COUNT,
-	    &lsi_properties_scsi },
-#if defined(__i386) || defined(__amd64)
-	{ " NEC CD-ROM DRIVE:260 ", (SD_CONF_BSET_PLAYMSF_BCD
-				    | SD_CONF_BSET_READSUB_BCD
-				    | SD_CONF_BSET_READ_TOC_ADDR_BCD
-				    | SD_CONF_BSET_NO_READ_HEADER
-				    | SD_CONF_BSET_READ_CD_XD4), NULL },
-
-	{ " NEC CD-ROM DRIVE:270 ", (SD_CONF_BSET_PLAYMSF_BCD
-				    | SD_CONF_BSET_READSUB_BCD
-				    | SD_CONF_BSET_READ_TOC_ADDR_BCD
-				    | SD_CONF_BSET_NO_READ_HEADER
-				    | SD_CONF_BSET_READ_CD_XD4), NULL },
-#endif /* __i386 || __amd64 */
-#endif /* sparc NON-fibre or NON-sparc platforms */
-
+	{ "SYMBIOS",		SD_CONF_BSET_NRR_COUNT, &symbios_properties },
+	{ "SEAGATE ST42400N",	SD_CONF_BSET_THROTTLE, &elite_properties },
+	{ "SEAGATE ST31200N",	SD_CONF_BSET_THROTTLE, &st31200n_properties },
+	{ "SEAGATE ST41600N",	SD_CONF_BSET_TUR_CHECK, NULL },
+	{ "CONNER  CP30540",	SD_CONF_BSET_NOCACHE,  NULL },
+	{ "*SUN0104*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN0207*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN0327*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN0340*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN0424*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN0669*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "*SUN1.0G*",		SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "SYMBIOS INF-01-00",	SD_CONF_BSET_FAB_DEVID, NULL },
+	{ "SYMBIOS",		SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT,
+				&symbios_properties },
+	{ "LSI",		SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_NRR_COUNT,
+				&lsi_properties_scsi },
+	{ " NEC CD-ROM DRIVE:260 ", SD_CONF_BSET_PLAYMSF_BCD|
+				SD_CONF_BSET_READSUB_BCD|
+				SD_CONF_BSET_READ_TOC_ADDR_BCD|
+				SD_CONF_BSET_NO_READ_HEADER|
+				SD_CONF_BSET_READ_CD_XD4,
+				NULL },
+	{ " NEC CD-ROM DRIVE:270 ", SD_CONF_BSET_PLAYMSF_BCD|
+				SD_CONF_BSET_READSUB_BCD|
+				SD_CONF_BSET_READ_TOC_ADDR_BCD|
+				SD_CONF_BSET_NO_READ_HEADER|
+				SD_CONF_BSET_READ_CD_XD4,
+				NULL },
 #if (defined(SD_PROP_TST))
-	{ "VENDOR  PRODUCT ", (SD_CONF_BSET_THROTTLE
-				| SD_CONF_BSET_CTYPE
-				| SD_CONF_BSET_NRR_COUNT
-				| SD_CONF_BSET_FAB_DEVID
-				| SD_CONF_BSET_NOCACHE
-				| SD_CONF_BSET_BSY_RETRY_COUNT
-				| SD_CONF_BSET_PLAYMSF_BCD
-				| SD_CONF_BSET_READSUB_BCD
-				| SD_CONF_BSET_READ_TOC_TRK_BCD
-				| SD_CONF_BSET_READ_TOC_ADDR_BCD
-				| SD_CONF_BSET_NO_READ_HEADER
-				| SD_CONF_BSET_READ_CD_XD4
-				| SD_CONF_BSET_RST_RETRIES
-				| SD_CONF_BSET_RSV_REL_TIME
-				| SD_CONF_BSET_TUR_CHECK), &tst_properties},
+	{ "VENDOR  PRODUCT ",	SD_CONF_BSET_THROTTLE|
+				SD_CONF_BSET_CTYPE|
+				SD_CONF_BSET_NRR_COUNT|
+				SD_CONF_BSET_FAB_DEVID|
+				SD_CONF_BSET_NOCACHE|
+				SD_CONF_BSET_BSY_RETRY_COUNT|
+				SD_CONF_BSET_PLAYMSF_BCD|
+				SD_CONF_BSET_READSUB_BCD|
+				SD_CONF_BSET_READ_TOC_TRK_BCD|
+				SD_CONF_BSET_READ_TOC_ADDR_BCD|
+				SD_CONF_BSET_NO_READ_HEADER|
+				SD_CONF_BSET_READ_CD_XD4|
+				SD_CONF_BSET_RST_RETRIES|
+				SD_CONF_BSET_RSV_REL_TIME|
+				SD_CONF_BSET_TUR_CHECK,
+				&tst_properties},
 #endif
 };
 
